--GearScore Database Export--
--Version 1.1

-- To use this addon use the command /gsexport
-- A file will be written to \World of Warcraft\WTF\Account\<AccountName>\SavedVariables\GearScoreExport.lua
--Inside the file you may see something like: 
--	
--GearScoreExportTable = {
--	"	Name	Level	Race	Class	Faction	GearScore	iLevel	", -- [1]
--	"	Phantomcat	80	TA	DR	H	5234	241	", -- [2]
--	"	Grimsmirk	80	TA	WA	H	3710	201	", -- [3]
--	"	Ethanatos	80	UN	WK	H	4187	210	", -- [4]
--	"	Humbolt	80	TA	DR	H	4427	218	", -- [5]
--	"	Topluz	80	TR	HU	H	4718	225	", -- [6]
--	"	Formouthica	80	UN	WK	H	4135	208	", -- [7]
--	"	Kiarre	80	BE	PR	H	4234	213	", -- [8]
--	"	Vantis	80	BE	PA	H	5127	237	", -- [9]
--}
--You need to delete the top and bottom lines then copy everything else to a spreadsheet program.
--I used Openoffice.org but it works great with googledocs spreadsheet as well. When pasting into
--googledocs it works perfectly. When pasting into OpenOffice.Org-Spreadsheet(Calc) a popup box
--appears, you need to delete the feild "Text Delimiter" which contains a " in it.
--From here you can edit and sort the information however you want then output it to a web page if 
--need be.

GearScoreExportTable = {} --Set and Erase the table.

local function ExportGearScoreDatabase()
	GearScoreExportTable = {} -- Again, Make sure to wipe any previous table.
	table.insert(GearScoreExportTable, "	Name	Level	Race	Class	Faction	GearScore	iLevel	") --insert Headers
	for i,v in pairs(GS_Data[GetRealmName()]["Players"]) do --Build the Exported Database. 
		if v["Name"] and v["Level"] and v["Race"] and v["Class"] and v["Faction"] and v["GearScore"] and v["Average"] and v["Guild"] then 
			table.insert(GearScoreExportTable, "	"..v["Name"].."	"..v["Guild"].."	"..v["Level"].."	"..GS_Races[v["Race"]].."	"..GS_Classes[v["Class"]].."	"..GS_Factions[v["Faction"]].."	"..v["GearScore"].."	"..v["Average"].."	") 
		end
	end
	print("Database successfully Exported. Please log out of the game to save file. Using Alt-F4 will delete the exported file.")			
end

local function GearScoreExport_OnEvent(MyNil, EventName, AddonName)
	if ( EventName == "ADDON_LOADED" ) and ( AddonName == "GearScoreExport" ) then
		GearScoreExportTable = {} --Erase the Database File even after Blizzard loads saved Variables. (To increase Memory)
		print("GSExport: Loaded") --Debug: Make sure addon loads correctly.
	end
end

local f = CreateFrame("Frame", "GearScoreExportFrame", UIParent);
f:SetScript("OnEvent", GearScoreExport_OnEvent);
f:RegisterEvent("ADDON_LOADED")
SlashCmdList["GSEXPORTSCRIPT"] = ExportGearScoreDatabase
SLASH_GSEXPORTSCRIPT1 = "/gsexport";